    MyDate$="April 19, 2013"
    MyVer=1.0
    MAXCOM=30
    PE=1
    SE=1
    Timeout=5000
    Verbose=0
    BF=1   ' Bitmap File Header
    DIB=2   ' Independent Image Bitmap Header
    CT=4   ' Color Table
    ID=8   ' Image Data
    comflag=0
    fileflag=0
    Local=1 'Enable Local Bitmap

    Dim goodcomm(MAXCOM)

    nomainwin

[setup.main.Window]
    WindowWidth = 640
    WindowHeight = 480
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)
    Name$="BitMap - Ver "; MyVer ; " " ; MyDate$
    statictext #main.sttext, "Communication", 20, 0, 150, 25
    texteditor #main.text, 1, 25, 300, 275
    statictext #main.sttext1, "Serial Port status", 20, 380, 150, 25
    textbox #main.text1, 1, 405, 150, 25
    statictext #main.sttext2, "File path", 195, 380, 150, 25
    textbox #main.text2, 175, 405, 475, 25
    statictext #main.stwidth, "BitMap Pixel Width", 20, 305, 150, 25
    textbox #main.tbwidth, 45, 330, 50, 25
    statictext #main.stheight, "BitMap Pixel Height", 175, 305, 150, 25
    textbox #main.tbheight, 205, 330, 50, 25
    statictext #main.stbitsperpixel, "BitMap Bits/Pixel", 310, 305, 150, 25
    textbox #main.tbbitsperpixel, 345, 330, 50, 25
    statictext #main.stcompression, "BitMap Compression", 475, 305, 150, 25
    textbox #main.tbcompression, 505, 330, 50, 25
    checkbox #main.cbHF, "Verbose HF", [EnableHF], [DisableHF], 20, 355, 100, 25
    checkbox #main.cbDIB, "Verbose DIB", [EnableDIB], [DisableDIB], 175, 355, 100, 25
    checkbox #main.cbCT, "Verbose CT", [EnableCT], [DisableCT], 310, 355, 100, 25
    checkbox #main.cbID, "Verbose ID", [EnableID], [DisableID], 475, 355, 100, 25
    statictext #main.sttextgb, "Bitmap drawing area", 345, 0, 150, 25
    graphicbox #main.gb, 325, 25, 275, 275
    comflag=0

[Selection]
    MENU #main, "&Quit", "&Quit", [End]
    MENU #main, "&COM", "&Select", [SelectCom]
    MENU #main, "&File", "&Load", [LoadFile],"&Send", [SendFile]
    MENU #main, "&Command", "&Command", [Command]
    open Name$ for window as #main
    print #main, "font ms_sans_serif 0 16"
    print #main, "trapclose [End]"

   ComClosed$="Com Port Closed"
    print #main.text1, ComClosed$ 
    timer 1000, [TimerDuty]

    goto [SelectCom]

[Idle]
    ComOpen$="Com"+str$(comflag)+":Open"
    if comflag=0 then
        if comflag<>comflagwas then print #main.text1, ComClosed$
'        gosub [HideAllData]
        goto   [IdleExit]
    else
        if comflag<>comflagwas then print #main.text1, ComOpen$
'        gosub [ShowAllData]
    end if

    ' Here's where we handle received characters!!!
    if lof(#commport) <> 0 then
        C$=input$(#commport,1)
        if C$<>chr$(10) then
            if instr(C$,chr$(13))<>0 then
                print #main.text,responsestring$;
                responsestring$=""
            else
                responsestring$=responsestring$+C$
            end if
        end if
    end if

[IdleExit]
    comflagwas=comflag
    scan
    goto [Idle]

[TimerDuty]
    if comflag=0 then goto   [TimerDutyNoComm]
   'stuff
    timer 1000, [TimerDuty]

[TimerDutyExit]
    goto [Idle]

[TimerDutyNoComm]
    timer 1000, [TimerDuty]
    goto [TimerDutyExit]

[SendFile]
    if fileflag=0 then
        print #main.text,"You must open a bitmap file first!"
        goto [Idle]
    end if

    if comflag=0 then
        print #main.text,"You must open a serial port first!"
        goto [Idle]
    end if

    gosub [StartTime]

    print #main.text,"Sending the BitMap"
    if Local=1 then
        print #main.gb, "cls"
        print #main.gb, "down"
        print #main.text, "Local Bitmap Display is enabled"
    else
        print #main.text, "Local Bitmap Display is disabled"
    end if


    Command$="@X=0"
    if PE=1 then
        if Verbose=1 then
            print #main.text, "!cls"
            if SE=0 then print #main.text, Command$
            if SE=1 then print #main.text, Command$;
        end if
    end if

    if SE=1 then print #commport, Command$

    Command$="@Y=0"
    if PE=1 then
        if Verbose=1 then
            if SE=0 then print #main.text, Command$
            if SE=1 then print #main.text, Command$;
        end if
    end if

    if SE=1 then print #commport, Command$

    Command$="BitMap=";Bitmapwidth;",";Bitmapheight

    if PE=1 then
        if Verbose=1 then
            if SE=0 then print #main.text, Command$
            if SE=1 then print #main.text, Command$;
        end if
    end if

    if PE=1 then print #commport, Command$

    if Bitmapsize=0 then Bitmapsize=Bitmapfilesize-Bitmapoffset

    select Bitmapbitperpixel
    case 1
        gosub [BitMap1]
    case 2
        gosub [BitMap2]
    case 4
        gosub [BitMap4]
    case 8
        gosub [BitMap8]
    case 16
        gosub [BitMap16]
    case 24
        gosub [BitMap24]
    case 32
        gosub [BitMap32]
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel has not been implemented"
    end select

[SendFileDump]
   while lof(#commport) <> 0
        C$=input$(#commport,1)
   wend

[SendFileExit]
    print #main.text,"...Finished"
    gosub [StopTime]
    print #main.gb, "flush"
    goto [Idle]

[StartTime]
    StartTime=time$("seconds")
    return

[StopTime]
    Duration=time$("seconds")-StartTime
    print #main.text,Duration;" seconds"
    return

[EnableHF]
    Verbose=Verbose or HF
    goto [Idle]

[DisableHF]
    Verbose=Verbose and not(HF)
    goto [Idle]

[EnableDIB]
    Verbose=Verbose or DIB
    goto [Idle]

[DisableDIB]
    Verbose=Verbose and not(DIB)
    goto [Idle]

[EnableCT]
    Verbose=Verbose or CT
    goto [Idle]

[DisableCT]
    Verbose=Verbose and not(CT)
    goto [Idle]

[EnableID]
    Verbose=Verbose or ID
    goto [Idle]

[DisableID]
    Verbose=Verbose and not(ID)
    goto [Idle]

[BitMap1]
    select Bitmapcompression
    case 0
        BytesPerRow=Bitmapsize/Bitmapheight
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to BytesPerRow-1
               for z=0 to 7
                    if (x*8+z)<Bitmapwidth then
                        offset=x+1
                        value=asc(mid$(Pixel$(y),offset,1))
                        if (value and 2^(7-z))=2^(7-z) then
                            index=1
                        else
                            index=0
                        end if

                        gosub [SendAPixel]
                        if count>Timeout then goto [BitMap1Exit]
                    end if
                next z
            next x
        next y
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
        goto [SendFileExit]
    end select

[BitMap1Exit]
    return

[BitMap2]
    select Bitmapcompression
    case 0
        BytesPerRow=Bitmapsize/Bitmapheight
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to BytesPerRow-1
                for z=0 to 3
                    if (x*4+z)<Bitmapwidth then
                        offset=x+1
                        value=asc(mid$(Pixel$(y),offset,1))
                        select z
                        case 0
                            index=int(value/64)
                        case 1
                            index=(int(value/16) and 3)
                        case 2
                            index=(int(value/4) and 3)
                        case 3
                            index=(value and 3)
                        end select

                        gosub [SendAPixel]
                        if count>Timeout then goto [BitMap2Exit]
                    end if
                next z
            next x
        next y
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
        goto [SendFileExit]
    end select

[BitMap2Exit]
    return

[BitMap4]
    select Bitmapcompression
    case 0
        BytesPerRow=Bitmapsize/Bitmapheight
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to BytesPerRow-1
                for z=0 to 1
                    if x*2+z<Bitmapwidth then
                        offset=x+1
                        value=asc(mid$(Pixel$(y),offset,1))
                        if z=0 then
                            index=int(value/16)
                        else
                            index=value-(int(value/16)*16)
                        end if

                        gosub [SendAPixel]
                        if count>Timeout then goto [BitMap3Exit]
                   end if
                next z
            next x
        next y
     case 1
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" has not been implemented"
     case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
        goto [SendFileExit]
    end select

[BitMap3Exit]
    return

[BitMap8]
    select Bitmapcompression
    case 0
        BytesPerRow=Bitmapsize/Bitmapheight
        z=0
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to BytesPerRow-1
                if x<Bitmapwidth then
                    offset=x+1
                    index=asc(mid$(Pixel$(y),offset,1))
                    gosub [SendAPixel]
                    if count>Timeout then goto [BitMap8Exit]
                end if
            next x
        next y
    case 2
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" has not been implemented"
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
    end select

[BitMap8Exit]
    return

[BitMap16]
    select Bitmapcompression
    case 0
        WordsPerRow=Bitmapsize/Bitmapheight
        z=0
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to WordsPerRow-1 step 2
                offset=x*2+1
                Red=hexdec(mid$(Pixel$(y),offset,2))/hexdec("&H800")
                Green=(hexdec(mid$(Pixel$(y),offset,2))-(Red*hexdec("&H800")/hexdec("&H20")))*2
                Blue=(hexdec(mid$(Pixel$(y),offset,2)) and hexdec("&H1F"))
                if Local=1 then
                    string$="color ";Red;" ";Green;" ";Blue
                    print #main.gb, string$
                    string$="set ";x/2;" ";Bitmapheight-y-1
                    print #main.gb, string$
                end if

                Command$="P=";dechex$((int(Red/8)*hexdec("&H800"))+(int(Green/4)*hexdec("&H20"))+int(Blue/8))
                if Verbose=1 then
                    If PE=1 then
                        if SE=0 then print #main.text, Command$
                        if SE=1 then print #main.text, Command$;
                    end if
                end if

                If SE=1 then print #commport, Command$

                if count>Timeout then goto [BitMap16Exit]
            next x
        next y
    case 3
         print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" has not been implemented"
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
    end select

[BitMap16Exit]
    return

[BitMap24]
    select Bitmapcompression
    case 0
        TripletsPerRow=int(Bitmapsize/Bitmapheight/3)
        z=0
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to TripletsPerRow-1
                offset=x*3+1
                Blue=asc(mid$(Pixel$(y),offset,1))
                Green=asc(mid$(Pixel$(y),offset+1,1))
                Red=asc(mid$(Pixel$(y),offset+2,1))
                if Local=1 then
                    string$="color ";Red;" ";Green;" ";Blue
                    print #main.gb, string$
                    string$="set ";x+z;" ";Bitmapheight-y-1
                    print #main.gb, string$
                end if

                Command$="P=";dechex$((int(Red/8)*hexdec("&H800"))+(int(Green/4)*hexdec("&H20"))+int(Blue/8))
                if Verbose=1 then
                    If PE=1 then
                        if SE=0 then print #main.text, Command$
                        if SE=1 then print #main.text, Command$;
                    end if
                end if

                If SE=1 then print #commport, Command$

                if count>Timeout then goto [BitMap24Exit]
            next x
        next y
    case 3
         print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" has not been implemented"
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
    end select

[BitMap24Exit]
    return

[BitMap32]
    select Bitmapcompression
    case 0
        DoubleWordsPerRow=int(Bitmapsize/Bitmapheight/4)
        z=0
        for y=Bitmapheight-1 to 0 step-1
            for x=0 to DoubleWordsPerRow-1
                offset=x*4+1
                Blue=asc(mid$(Pixel$(y),offset+1,1))
                Green=asc(mid$(Pixel$(y),offset+2,1))
                Red=asc(mid$(Pixel$(y),offset+3,1))
                if Local=1 then
                    string$="color ";Red;" ";Green;" ";Blue
                    print #main.gb, string$
                    string$="set ";x+z;" ";Bitmapheight-y-1
                    print #main.gb, string$
                end if

                Command$="P=";dechex$((int(Red/8)*hexdec("&H800"))+(int(Green/4)*hexdec("&H20"))+int(Blue/8))
                if Verbose=1 then
                    If PE=1 then
                        if SE=0 then print #main.text, Command$
                        if SE=1 then print #main.text, Command$;
                    end if
                end if

                If SE=1 then print #commport, Command$

                if count>Timeout then goto [BitMap32Exit]
            next x
        next y
    case 3
         print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" has not been implemented"
    case else
        print #main.text, Bitmapbitperpixel;" bits/per pixel with"
        print #main.text, "Compression=";Bitmapcompression;" is not legal"
    end select

[BitMap32Exit]
    return

[SendAPixel]
    Red=hexdec(Red$(index))
    Green=hexdec(Green$(index))
    Blue=hexdec(Blue$(index))
    if Local=1 then
        string$="color ";Red;" ";Green;" ";Blue
        print #main.gb, string$
        string$="set ";x*(8/Bitmapbitperpixel)+z;" ";Bitmapheight-y-1
        print #main.gb, string$
    end if

    Command$="P=";dechex$((int(Red/8)*hexdec("&H800"))+(int(Green/4)*hexdec("&H20"))+int(Blue/8))
    if Verbose=1 then
        If PE=1 then
            if SE=0 then print #main.text, Command$
            if SE=1 then print #main.text, Command$;
        end if
    end if

    If SE=1 then print #commport, Command$

    return

[LoadFile]
    filedialog "Open  a Bit Map file", "*.bmp", fileName$
    print #main.text2, fileName$
    open fileName$ for input as #file

    gosub [StartTime]

    x=0
    print #main.text,"Loading the BitMap"
    Header$=""
    while (eof(#file)=0 and x<14)
        Header$=Header$+input$(#file, 1)
        x=x+1
    wend
    gosub [DeconstructHeader]

    Core$=""
    max=x+4
    while (eof(#file)=0 and x<max)
        Core$=Core$+input$(#file, 1)
        x=x+1
    wend
    Coresize=asc(mid$(Core$,1,1))+(asc(mid$(Core$,2,1))*hexdec("&H100"))+(asc(mid$(Core$,3,1))*hexdec("&H10000"))+(asc(mid$(Core$,4,1))*hexdec("&H1000000"))
    if Coresize<>40 then print #main.text, "Not a legal bmp" : goto [LoadFileClose]
    max=x+Coresize-4
    while (eof(#file)=0 and x<max)
        Core$=Core$+input$(#file, 1)
        x=x+1
    wend
    print #main.text,"Core Length:";len(Core$)
    gosub [DeconstructCore]

    Colortable$=""
    Bitmapcolortablesize=(Bitmapoffset-x)/4
    if (Bitmapcolortablesize)<>0 then
        redim Colortable$(Bitmapcolortablesize)
        for z=0 to Bitmapcolortablesize-1
            Colortable$(z)=""
            max=x+4
            while (eof(#file)=0 and x<max)
                Colortable$=Colortable$+input$(#file, 1)
                x=x+1
            wend
        next z
        gosub [DeconstructColortable]
    end if

    redim Pixel$(Bitmapheight)
    x=0
    for z=0 to Bitmapheight-1
        Pixel$(z)=""
        max=(Bitmapsize/Bitmapheight)+x
        while (eof(#file)=0 and x<max)
            Pixel$(z)=Pixel$(z)+input$(#file, 1)
            if (Verbose and ID)=ID then
                print #main.text, "Pixel$";z;"(";len(Pixel$(z))-1;")=";asc(mid$(Pixel$(z),len(Pixel$(z)),1))
            end if
            x=x+1
        wend
    next z

[LoadFileClose]
    close #file
    print #main.text, ""
    print #main.text, "Image Data Read=";x
'    if Verbose=1 then
'        for x = 0 to Bitmapheight-1
'            for y=0 to len(Pixel$(x))
'                print #main.text, "Pixel$";x;"(";y;")=";asc(mid$(Pixel$(x),y+1,1))
'            next y
'        next x
'    end if
    print #main.text,"...Finished"

    gosub [StopTime]

    fileflag=1
    goto [Idle]

[DeconstructColortable]
    print #main.text, "Colortable Entries=";len(Colortable$)/4
    redim Red$((len(Colortable$)/4)-1)
    redim Green$((len(Colortable$)/4)-1)
    redim Blue$((len(Colortable$)/4)-1)
    for z=0 to (len(Colortable$)/4)-1
        Red$(z)=dechex$(asc(mid$(Colortable$,(z*4)+3,1)))
        if len(Red$(z))=1 then Red$(z)="0"+Red$(z)
        Green$(z)=dechex$(asc(mid$(Colortable$,(z*4)+2,1)))
        if len(Green$(z))=1 then Green$(z)="0"+Green$(z)
        Blue$(z)=dechex$(asc(mid$(Colortable$,(z*4)+1,1)))
        if len(Blue$(z))=1 then Blue$(z)="0"+Blue$(z)
    next z
    if (Verbose and CT)=CT then
        print #main.text, ""
        print #main.text, "Color Table Information (RGB)..."

        for z=0 to (len(Colortable$)/4)-1
            print #main.text,"Color";z;"=";Red$(z);Green$(z);Blue$(z)
        next z
    end if

    return


[DeconstructCore]
    Bitmapwidth=asc(mid$(Core$,5,1))+(asc(mid$(Core$,6,1))*hexdec("&H100"))+(asc(mid$(Core$,7,1))*hexdec("&H10000"))+(asc(mid$(Core$,8,1))*hexdec("&H1000000"))
    Bitmapheight=asc(mid$(Core$,9,1))+(asc(mid$(Core$,10,1))*hexdec("&H100"))+(asc(mid$(Core$,11,1))*hexdec("&H10000"))+(asc(mid$(Core$,12,1))*hexdec("&H1000000"))
    Bitmapplanes=asc(mid$(Core$,13,1))+(asc(mid$(Core$,14,1))*hexdec("&H100"))
    Bitmapbitperpixel=asc(mid$(Core$,15,1))+(asc(mid$(Core$,16,1))*hexdec("&H100"))
    Bitmapcompression=asc(mid$(Core$,17,1))+(asc(mid$(Core$,18,1))*hexdec("&H100"))+(asc(mid$(Core$,19,1))*hexdec("&H10000"))+(asc(mid$(Core$,20,1))*hexdec("&H1000000"))
    Bitmapsize=asc(mid$(Core$,21,1))+(asc(mid$(Core$,22,1))*hexdec("&H100"))+(asc(mid$(Core$,23,1))*hexdec("&H10000"))+(asc(mid$(Core$,24,1))*hexdec("&H1000000"))
    Bitmaphorizontalres=asc(mid$(Core$,25,1))+(asc(mid$(Core$,26,1))*hexdec("&H100"))+(asc(mid$(Core$,27,1))*hexdec("&H10000"))+(asc(mid$(Core$,28,1))*hexdec("&H1000000"))
    Bitmapverticalres=asc(mid$(Core$,29,1))+(asc(mid$(Core$,30,1))*hexdec("&H100"))+(asc(mid$(Core$,31,1))*hexdec("&H10000"))+(asc(mid$(Core$,32,1))*hexdec("&H1000000"))
    Bitmapcolors=asc(mid$(Core$,33,1))+(asc(mid$(Core$,34,1))*hexdec("&H100"))+(asc(mid$(Core$,35,1))*hexdec("&H10000"))+(asc(mid$(Core$,36,1))*hexdec("&H1000000"))
    Bitmapimportantcolors=asc(mid$(Core$,37,1))+(asc(mid$(Core$,38,1))*hexdec("&H100"))+(asc(mid$(Core$,39,1))*hexdec("&H10000"))+(asc(mid$(Core$,40,1))*hexdec("&H1000000"))

    if (Verbose and DIB)=DIB then
        print #main.text, ""
        print #main.text, "Independent Image Bitmap Information..."
        print #main.text, "Core Length=";len(Core$)
        print #main.text,"Core Size=";Coresize
        print #main.text,"Bitmap Width=";Bitmapwidth
        print #main.text,"Bitmap Height=";Bitmapheight
        print #main.text,"Bitmap Planes=";Bitmapplanes
        print #main.text,"Bitmap Bits/Pixel=";Bitmapbitperpixel
        print #main.text,"Bitmap Compression=";Bitmapcompression
        print #main.text,"Bitmap Size=";Bitmapsize
        print #main.text,"Bitmap Horizontal Resolution=";Bitmaphorizontalres
        print #main.text,"Bitmap Vertical Resolution=";Bitmapverticalres
        print #main.text,"Bitmap Colors=";Bitmapcolors
        print #main.text,"Bitmap Important Colors=";Bitmapimportantcolors
    end if

    print #main.tbwidth,Bitmapwidth
    print #main.tbheight,Bitmapheight
    print #main.tbbitsperpixel,Bitmapbitperpixel
    print #main.tbcompression,Bitmapcompression

    return

[DeconstructHeader]
    Bitmaptype$=left$(Header$,2)
    Bitmapfilesize=asc(mid$(Header$,3,1))+(asc(mid$(Header$,4,1))*hexdec("&H100"))+(asc(mid$(Header$,5,1))*hexdec("&H10000"))+(asc(mid$(Header$,6,1))*hexdec("&H1000000"))
    Reserved1=asc(mid$(Header$,7,1))+(asc(mid$(Header$,8,1))*hexdec("&H100"))
    Reserved2=asc(mid$(Header$,9,1))+(asc(mid$(Header$,10,1))*hexdec("&H100"))
    Bitmapoffset=asc(mid$(Header$,11,1))+(asc(mid$(Header$,12,1))*hexdec("&H100"))+(asc(mid$(Header$,13,1))*hexdec("&H10000"))+(asc(mid$(Header$,14,1))*hexdec("&H1000000"))

    if (Verbose and BF)=BF then
        print #main.text, ""
        print #main.text, "Bitmap Header Information..."
        print #main.text, "Header Length=";len(Header$)
        print #main.text,"Bitmap Type=";Bitmaptype$
        print #main.text,"Bitmap Filesize=";Bitmapfilesize
        print #main.text,"Reserved 1=";Reserved1
        print #main.text,"Reserved 2=";Reserved2
        print #main.text,"Bitmap Offset=";Bitmapoffset
    end if

    return

[Command]
    if comflag=0 then
        print #main.text,"You must open a serial port first!"
        goto [Idle]
    end if
    Command$=""
    prompt "Send a TFT Command"; Command$
    if Command$<>"" then
        print #main.text, "!cls"
        print #commport, Command$
        print #main.text, Command$;
        print #main.text," -> ";
        responsestring$=""
    end if
    goto [Idle]

[SelectCom]
    WindowWidth = 220
    WindowHeight = 260
    UpperLeftX=int((DisplayWidth-WindowWidth)/2)
    UpperLeftY=int((DisplayHeight-WindowHeight)/2)
    Name$="Comm Port Selection"

    RADIOBUTTON #commselect.but1, "Com1", [OpenCom1], [CloseCom1], 10, 10, 60, 20
    RADIOBUTTON #commselect.but2, "Com2", [OpenCom2], [CloseCom2], 70, 10, 60, 20
    RADIOBUTTON #commselect.but3, "Com3", [OpenCom3], [CloseCom3], 130, 10, 60, 20
    RADIOBUTTON #commselect.but4, "Com4", [OpenCom4], [CloseCom4], 10, 30, 60, 20
    RADIOBUTTON #commselect.but5, "Com5", [OpenCom5], [CloseCom5], 70, 30, 60, 20
    RADIOBUTTON #commselect.but6, "Com6", [OpenCom6], [CloseCom6], 130, 30, 60, 20
    RADIOBUTTON #commselect.but7, "Com7", [OpenCom7], [CloseCom7], 10, 50, 60, 20
    RADIOBUTTON #commselect.but8, "Com8", [OpenCom8], [CloseCom8], 70, 50, 60, 20
    RADIOBUTTON #commselect.but9, "Com9", [OpenCom9], [CloseCom9], 130, 50, 60, 20
    RADIOBUTTON #commselect.but10, "Com10", [OpenCom10], [CloseCom10], 10, 70, 60, 20
    RADIOBUTTON #commselect.but11, "Com11", [OpenCom11], [CloseCom11], 70, 70, 60, 20
    RADIOBUTTON #commselect.but12, "Com12", [OpenCom12], [CloseCom12], 130, 70, 60, 20
    RADIOBUTTON #commselect.but13, "Com13", [OpenCom13], [CloseCom13], 10, 90, 60, 20
    RADIOBUTTON #commselect.but14, "Com14", [OpenCom14], [CloseCom14], 70, 90, 60, 20
    RADIOBUTTON #commselect.but15, "Com15", [OpenCom15], [CloseCom15], 130, 90, 60, 20
    RADIOBUTTON #commselect.but16, "Com16", [OpenCom16], [CloseCom16], 10, 110, 60, 20
    RADIOBUTTON #commselect.but17, "Com17", [OpenCom17], [CloseCom17], 70, 110, 60, 20
    RADIOBUTTON #commselect.but18, "Com18", [OpenCom18], [CloseCom18], 130, 110, 60, 20
    RADIOBUTTON #commselect.but19, "Com19", [OpenCom19], [CloseCom19], 10, 130, 60, 20
    RADIOBUTTON #commselect.but20, "Com20", [OpenCom20], [CloseCom20], 70, 130, 60, 20
    RADIOBUTTON #commselect.but21, "Com21", [OpenCom21], [CloseCom21], 130, 130, 60, 20
    RADIOBUTTON #commselect.but22, "Com22", [OpenCom22], [CloseCom22], 10, 150, 60, 20
    RADIOBUTTON #commselect.but23, "Com23", [OpenCom23], [CloseCom23], 70, 150, 60, 20
    RADIOBUTTON #commselect.but24, "Com24", [OpenCom24], [CloseCom24], 130, 150, 60, 20
    RADIOBUTTON #commselect.but25, "Com25", [OpenCom25], [CloseCom25], 10, 170, 60, 20
    RADIOBUTTON #commselect.but26, "Com26", [OpenCom26], [CloseCom26], 70, 170, 60, 20
    RADIOBUTTON #commselect.but27, "Com27", [OpenCom27], [CloseCom27], 130, 170, 60, 20
    RADIOBUTTON #commselect.but28, "Com28", [OpenCom28], [CloseCom28], 10, 190, 60, 20
    RADIOBUTTON #commselect.but29, "Com29", [OpenCom29], [CloseCom29], 70, 190, 60, 20
    RADIOBUTTON #commselect.but30, "Com30", [OpenCom30], [CloseCom30], 130, 190, 60, 20
    open Name$ for window as #commselect
    print #commselect, "font ms_sans_serif 0 16"
    print #commselect, "trapclose [SelectComClose]"

    if comflag<>0 then
        close #commport
        comflag=0
    end if

    gosub   [Look4Com]
    if goodcomcount=0 then
        print #main.text1, "No Serial Ports avaialable"
        close #commselect
    else
         print #main.text1, "Select Serial Port"
    end if

[SelectComExit]
    print #main.gb, "redraw"
    goto    [Idle]

[SelectComClose]
    close #commselect
    comflag=0
    goto    [Idle]

[Look4Com]
    goodcomcount=0
    for x=1 to MAXCOM
        print #main.text1,"Checking COM";x
        gosub   [CheckCom]
    next x
    gosub [EnableAllGoodCom]
    return

[EnableAllGoodCom]
        if goodcomm(1)=1 then
            print #commselect.but1, "enable"
        else
            print #commselect.but1, "disable"
        end if

        if goodcomm(2)=2 then
            print #commselect.but2, "enable"
        else
            print #commselect.but2, "disable"
        end if

        if goodcomm(3)=3 then
            print #commselect.but3, "enable"
        else
            print #commselect.but3, "disable"
        end if

        if goodcomm(4)=4 then
            print #commselect.but4, "enable"
        else
            print #commselect.but4, "disable"
        end if

        if goodcomm(5)=5 then
            print #commselect.but5, "enable"
        else
            print #commselect.but5, "disable"
        end if

        if goodcomm(6)=6 then
            print #commselect.but6, "enable"
        else
            print #commselect.but6, "disable"
        end if

        if goodcomm(7)=7 then
            print #commselect.but7, "enable"
        else
            print #commselect.but7, "disable"
        end if

        if goodcomm(8)=8 then
            print #commselect.but8, "enable"
        else
            print #commselect.but8, "disable"
        end if

        if goodcomm(9)=9 then
            print #commselect.but9, "enable"
        else
            print #commselect.but9, "disable"
        end if

       if goodcomm(10)=10 then
            print #commselect.but10, "enable"
        else
            print #commselect.but10, "disable"
        end if

       if goodcomm(11)=11 then
            print #commselect.but11, "enable"
        else
            print #commselect.but11, "disable"
        end if

       if goodcomm(12)=12 then
            print #commselect.but12, "enable"
        else
            print #commselect.but12, "disable"
        end if

        if goodcomm(13)=13 then
            print #commselect.but13, "enable"
        else
            print #commselect.but13, "disable"
        end if

        if goodcomm(14)=14 then
            print #commselect.but14, "enable"
        else
            print #commselect.but14, "disable"
        end if

        if goodcomm(15)=15 then
            print #commselect.but15, "enable"
        else
            print #commselect.but15, "disable"
        end if

        if goodcomm(16)=16 then
            print #commselect.but16, "enable"
        else
            print #commselect.but16, "disable"
        end if

        if goodcomm(17)=17 then
            print #commselect.but17, "enable"
        else
            print #commselect.but17, "disable"
        end if

        if goodcomm(18)=18 then
            print #commselect.but18, "enable"
        else
            print #commselect.but18, "disable"
        end if

        if goodcomm(19)=19 then
            print #commselect.but19, "enable"
        else
            print #commselect.but19, "disable"
        end if

        if goodcomm(20)=20 then
            print #commselect.but20, "enable"
        else
            print #commselect.but20, "disable"
        end if

        if goodcomm(21)=21 then
            print #commselect.but21, "enable"
        else
            print #commselect.but21, "disable"
        end if

        if goodcomm(22)=22 then
            print #commselect.but22, "enable"
        else
            print #commselect.but22, "disable"
        end if

        if goodcomm(23)=23 then
            print #commselect.but23, "enable"
        else
            print #commselect.but23, "disable"
        end if

        if goodcomm(24)=24 then
            print #commselect.but24, "enable"
        else
            print #commselect.but24, "disable"
        end if

        if goodcomm(25)=25 then
            print #commselect.but25, "enable"
        else
            print #commselect.but25, "disable"
        end if

        if goodcomm(26)=26 then
            print #commselect.but26, "enable"
        else
            print #commselect.but26, "disable"
        end if

        if goodcomm(27)=27 then
            print #commselect.but27, "enable"
        else
            print #commselect.but27, "disable"
        end if

        if goodcomm(28)=28 then
            print #commselect.but28, "enable"
        else
            print #commselect.but28, "disable"
        end if

        if goodcomm(29)=29 then
            print #commselect.but29, "enable"
        else
            print #commselect.but29, "disable"
        end if

        if goodcomm(30)=30 then
            print #commselect.but30, "enable"
        else
            print #commselect.but30, "disable"
        end if

    return

[OpenCom]
        oncomerror [NoOpenCom]
        COM$="com"+str$(x)+":115200,n,8,2,CS0,DS0"
        open COM$ for random as #commport
        goodcomcount=1

[NoOpenCom]
        return

[CheckCom]
        oncomerror [NoCheckCom]

        COM$="com"+str$(x)+":115200,n,8,2,CS0,DS0"
        open COM$ for random as #commport
        goodcomcount=goodcomcount+1
        goodcomm(x)=x
        close #commport
        goto [CheckComExit]

[NoCheckCom]
        goodcomm(x)=0

[CheckComExit]
        return

[OpenCom1]
    if comflag<>0 then close #commport : comflag=0
    x=1
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom1]
    goto    [CloseComExit]]

[OpenCom2]
    if comflag<>0 then close #commport : comflag=0
    x=2
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom2]
    goto    [CloseComExit]

[OpenCom3]
    if comflag<>0 then close #commport : comflag=0
    x=3
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom3]
    goto    [CloseComExit]

[OpenCom4]
    if comflag<>0 then close #commport : comflag=0
    x=4
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom4]
    goto    [CloseComExit]


[OpenCom5]
    if comflag<>0 then close #commport : comflag=0
    x=5
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom5]
    goto    [CloseComExit]

[OpenCom6]
    if comflag<>0 then close #commport : comflag=0
    x=6
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom6]
    goto    [CloseComExit]

[OpenCom7]
    if comflag<>0 then close #commport : comflag=0
    x=7
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom7]
    goto    [CloseComExit]

[OpenCom8]
    if comflag<>0 then close #commport : comflag=0
    x=8
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom8]
    goto    [CloseComExit]

[OpenCom9]
    if comflag<>0 then close #commport : comflag=0
    x=9
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom9]
    goto    [CloseComExit]

[OpenCom10]
    if comflag<>0 then close #commport : comflag=0
    x=10
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom10]
    goto    [CloseComExit]

[OpenCom11]
    if comflag<>0 then close #commport : comflag=0
    x=11
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom11]
    goto    [CloseComExit]

[OpenCom12]
    if comflag<>0 then close #commport : comflag=0
    x=12
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom12]
    goto    [CloseComExit]

[OpenCom13]
    if comflag<>0 then close #commport : comflag=0
    x=13
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom13]
    goto    [CloseComExit]

[OpenCom14]
    if comflag<>0 then close #commport : comflag=0
    x=14
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom14]
    goto    [CloseComExit]

[OpenCom15]
    if comflag<>0 then close #commport : comflag=0
    x=15
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom15]
    goto    [CloseComExit]

[OpenCom16]
    if comflag<>0 then close #commport : comflag=0
    x=16
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom16]
    goto    [CloseComExit]

[OpenCom17]
    if comflag<>0 then close #commport : comflag=0
    x=17
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom17]
    goto    [CloseComExit]

[OpenCom18]
    if comflag<>0 then close #commport : comflag=0
    x=18
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom18]
    goto    [CloseComExit]

[OpenCom19]
    if comflag<>0 then close #commport : comflag=0
    x=19
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom19]
    goto    [CloseComExit]

[OpenCom20]
    if comflag<>0 then close #commport : comflag=0
    x=20
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom20]
    goto    [CloseComExit]

[OpenCom21]
    if comflag<>0 then close #commport : comflag=0
    x=21
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom21]
    goto    [CloseComExit]

[OpenCom22]
    if comflag<>0 then close #commport : comflag=0
    x=22
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom22]
    goto    [CloseComExit]

[OpenCom23]
    if comflag<>0 then close #commport : comflag=0
    x=23
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom23]
    goto    [CloseComExit]

[OpenCom24]
    if comflag<>0 then close #commport : comflag=0
    x=24
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom24]
    goto    [CloseComExit]

[OpenCom25]
    if comflag<>0 then close #commport : comflag=0
    x=25
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom25]
    goto    [CloseComExit]

[OpenCom26]
    if comflag<>0 then close #commport : comflag=0
    x=26
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom26]
    goto    [CloseComExit]

[OpenCom27]
    if comflag<>0 then close #commport : comflag=0
    x=27
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom27]
    goto    [CloseComExit]

[OpenCom28]
    if comflag<>0 then close #commport : comflag=0
    x=28
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom28]
    goto    [CloseComExit]

[OpenCom29]
    if comflag<>0 then close #commport : comflag=0
    x=29
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom29]
    goto    [CloseComExit]

[OpenCom30]
    if comflag<>0 then close #commport : comflag=0
    x=30
    goodcomcount=0
    gosub   [OpenCom]
    comflag=x
    goto    [OpenComExit]

[CloseCom30]
    goto    [CloseComExit]

[OpenComExit]
    close #commselect
    goto    [Idle]

[CloseComExit]
    close #commport
    goto    [Idle]

[End]
    if comflag<>0 then close #commport
    close #main
    end
